'
' -----------------------------------------------------------------------
' Passing Double to FB From RQ           June 10th, 2006     by  Jacques
' -----------------------------------------------------------------------
' NOTES:
' IN THE FB PROCEDURE, NEARLY EVERYTHING CAN BE DONE WITH DOUBLES.
' - PASSING DOUBLE FROM RAPIDQ TO A FB FUNCTIONS CANNOT BE DONE THE USUAL
'   WAY WITHOUT WITHOUT HEAVY REWRITING. THE EASY WAY IS TO PASS YOUR DOUBLES
'   IN AN ARRAY OF DOUBLE OR IN A TYPE (THE DOUBLE CONSTANTES REQUIRED HAVE TO
'   BE PASSED TOO FROM RAPIDQ)
' - YOU CAN DIM AS MANY LOCAL DOUBLE AS YOU WANT
' - ALL THE MATH FUNCTION ARE AVAILABLE ... I DID NOT CHECK EVERYTHING,
'   BUT *,/, SQR, SIN, ... are OK.
' - ^ : EXPONENTIATION BUGS. MOST OF THE TIME  X*X*X = X ^ 3  WILL SOLVE
'       THIS PROBLEM (THERE IS A MATH LIB IN FB ... MAYBE YOU CAN IMPORT
'       THE PART OF IT YOU NEED ?)
' - CANNOT SET IMMEDIAT VALUES
'       myDbl = 12.34           this will bug at compile time
'   YOU'LL HAVE TO PASS YOUR CONSTANTES IN THE ARRAY PASSED FROM RAPIDQ
' REMARK:
'  Some FPU X86 Mnemonics are different from AS/GCC and NASM ! Not all
'  are translated to NASM, it may exceptionally return an NASM COMPILE
'  ERROR ???
' -----------------------------------------------------------------------
' COMPILE ME WITH FbToRqInc  Menu Compile/FB to RQ Inc ...
' -----------------------------------------------------------------------
'
Option Explicit
Function DoubleTest (ByVal dbl As Double ptr,b,c,d) As Long
	Dim As Double dbl3, dbl4, dbl5, dbl6
	dbl3 = dbl[0] * dbl[1]
     dbl4 = dbl[1]/dbl[0]
     dbl5 = sin (dbl4)
     dbl6 = (dbl5 + dbl4) * (sin(dbl[1]))
     dbl6 = cos(dbl[1])
     dbl6 = atn (dbl[1])
     dbl3 = SQR (dbl3)
     dbl[2] = dbl3
End Function
' -----------------------------------------------------------------------
' There may be a better solution ??? I am not an FB expert !
' -----------------------------------------------------------------------
